//Definir todas las variables con sus puertos
#define M1 10   //Motor 1
#define M1E 9   //Motor 1 Enable
#define M2 6    //Motor 2
#define M2E 5   //Motor 2 Enable
#define BZ 12   //Buzzer
#define P 8      //Pinzas
#define PE 7     //Pinzas Enable
#define FC1 19   //Final de Carrera 1
#define FC2 14   //Final de Carrera 2
#define BZ 12   //Buzzer
#define L1 15   //LEDs 1 Adelante
#define L2 16   //LEDs 2 Atrás
#define L3 17   //LEDs 3 Izquierda
#define L4 18   //LEDs 4 Derecha
#define CNY2 3   //CNY 2
#define CNY1 2   //CNY 1

//Definir variables para la velocidad de cada motor al 50% de 255
float SPD1 = 126.5; //Velocidad para el motor 1
float SPD2 = 125.5; //Velocidad para el motor 2

//Variables de los Encoders de cada motor inicializada a 0
int E1 = 0; //Encoder del motor 1
int E2 = 0; //Encoder del motor 2

//Definir variables de las notas musicales
int Do[5] = {131, 262, 523, 1046, 2093}; // Nota Do
int DoS[5] = {139, 277, 554, 1108, 2217}; //Nota Do#
int Re[5] = {147, 294, 587, 1175, 2349}; //Nota Re
int ReS[5] = {156, 311, 622, 1244, 2489}; //Nota Re#
int Mi[5] = {165, 330, 659, 1319, 2637}; //Nota Mi
int Fa[5] = {175, 349, 698, 1397, 2794}; //Nota Fa
int FaS[5] = {185, 370, 740, 1480, 2960}; //Nota Fa#
int Sol[5] = {196, 392, 784, 1568, 3136}; //Nota Sol
int SolS[5] = {208, 415, 831, 1661, 3322}; //Nota Sol#
int La[5] = {220, 440, 880, 1760, 3520}; //Nota La
int LaS[5] = {233, 466, 932, 1866, 3729}; //Nota La#
int Si[5] = {247, 494, 988, 1976, 3951}; //Nota Si

//Funciones para las interrupciones de los encoders
void Encoder1() //Función para el Encoder 1
{
  E1++; //Contador de pasos para el Encoder 1
}
void Encoder2() //Función para el Encoder 2
{
  E2++; //Contador de pasos para el Encoder 2
}

void setup()
{ //Definir entradas y salidas
  pinMode(M1, OUTPUT); //IN del motor 1 como salida
  pinMode(M1E, OUTPUT); //Enable del motor 1 como salida
  pinMode(M2, OUTPUT);//IN del motor 2 como salida
  pinMode(M2E, OUTPUT); //Enable del motor 2 como salida
  pinMode(BZ, OUTPUT); //Buzzer como salida
  pinMode(P, OUTPUT); // IN de las pinzas como salida
  pinMode(PE, OUTPUT);  //Enable de las pinzas como salida
  pinMode(FC1, INPUT);  //Final de Carrera 1 como salida
  pinMode(FC2, INPUT);  //Final de Carrera 2 como salida
  pinMode(L1, OUTPUT); // Led derecho
  pinMode(L2, OUTPUT); // Led izquierdo
  pinMode(L3, OUTPUT); // Led Trasero central
  pinMode(L4, OUTPUT); // Led Trasero laterales
  pinMode(CNY2, INPUT);  // CNY2 como entrada
  pinMode(CNY1, INPUT);  // CNY2 como entrada
  attachInterrupt(0, Encoder1, CHANGE); //Definir interrupciones para la función del encoder 1 a cada cambio de nivel
  attachInterrupt(1, Encoder2, CHANGE); //Definir interrupciones para la función del encoder 2 a cada cambio de nivel
  Serial.begin(9600); //Conexión Bluetooth
}

void adelante() //Función para que ande hacia adelante
{
  while (E1 < 65) // Mientras que el encoder 1 cambie 65 veces
  {
    analogWrite(M1E, SPD1); // Activa Motor Derecho a la velocidad escogida, 50% si no elije nada
    analogWrite(M2E, SPD2); // Activa Motor Izquierda a la velocidad escogida, 50% si no elije nada
    digitalWrite(M1, HIGH); // Motor Derecho hacia adelante
    digitalWrite(M2, HIGH); // Motor Izquierda hacia adelante
  }
  digitalWrite(M1E, LOW); // Desactiva Motor Derecho
  digitalWrite(M2E, LOW); // Desactiva Motor Izquierda
}

void atras() //Función para que ande hacia atrás
{
  while (E1 < 65) // Mientras que el encoder 1 cambie 65 veces
  {
    analogWrite(M1E, SPD1); // Activa Motor Derecho a la velocidad escogida, 50% si no elije nada
    analogWrite(M2E, SPD2); // Activa Motor Izquierda a la velocidad escogida, 50% si no elije nada
    digitalWrite(M2, LOW); // Motor Izquierda hacia atras
    digitalWrite(M1, LOW); // Motor Derecho hacia atras
  }
  digitalWrite(M1E, LOW); // Desactiva Motor Derecho
  digitalWrite(M2E, LOW); // Desactiva Motor Izquierda
}

void derecha() //Función para que ande hacia la derecha
{
  while (E2 < 2) // Mientras que el encoder 2 cambie 2 vez; para que se ajuste a la siguente celda
  {
    analogWrite(M1E, SPD1); // Activa Motor Derecho a la velocidad escogida, 50% si no elije nada
    analogWrite(M2E, SPD2); // Activa Motor Izquierda a la velocidad escogida, 50% si no elije nada
    digitalWrite(M1, HIGH); // Motor Derecho hacia adelante
    digitalWrite(M2, HIGH); // Motor Izquierda hacia adelante
  }
  digitalWrite(M1E, LOW); // Desactiva Motor Derecho
  digitalWrite(M2E, LOW); // Desactiva Motor Izquierda
  while (E1 < 58) // Mientras que el encoder 1 cambie 58 vez
  {
    analogWrite(M1E, SPD1); // Activa Motor Derecho a la velocidad escogida, 50% si no elije nada
    digitalWrite(M1, HIGH); // Motor Derecho hacia adelante
  }
  digitalWrite(M1E, LOW); // Desactiva Motor Derecho
}

void izquierda() //Función para que ande hacia la izquierda
{
  while (E1 < 2) // Mientras que el encoder 2 cambie 2 vez; para que se ajuste a la siguente celda
  {
    analogWrite(M1E, SPD1); // Activa Motor Derecho a la velocidad escogida, 50% si no elije nada
    analogWrite(M2E, SPD2); // Activa Motor Izquierda a la velocidad escogida, 50% si no elije nada
    digitalWrite(M1, HIGH); // Motor Derecho hacia adelante
    digitalWrite(M2, HIGH); // Motor Izquierda hacia adelante
    digitalWrite(M1E, LOW); // Desactiva Motor Derecho
    digitalWrite(M2E, LOW); // Desactiva Motor Izquierda
  }
  while (E2 < 58) // Mientras que el encoder 2 cambie 58 vez
  {
    analogWrite(M2E, SPD2); // Activa Motor Izquierda a la velocidad escogida, 50% si no elije nada
    digitalWrite(M2, HIGH); // Motor Izquierda hacia adelante
  }
  digitalWrite(M2E, LOW); // Desactiva Motor Izquierda
}

void cerrar_pinzas() //Función para cerrar pinzas
{
  while (digitalRead(FC2) == 1) // Mientras el Final de Carrera no esté pulsado
  {
    digitalWrite(PE, HIGH); // Activa Pinzas
    digitalWrite(P, HIGH); // Pinzas para cerrar
  }

  if (digitalRead(FC2) == 0) // Si el Final de Carrera está pulsado
  {
    d 
void abrir_pinzas() //Función para abrir pinzas
{
  while (digitalRead(FC1) == 0) // Mientras el Final de Carrera no esté pulsado
  {
    digitalWrite(PE, HIGH); // Activa Pinzas
    digitalWrite(P, LOW); // Pinzas para abrir
  }
  if (digitalRead(FC1) == 1)  // Si el Final de Carrera está pulsado
  {
    digitalWrite(PE, LOW); // Desactivar Pinzas
  }

  delay(30); //para asegurar el abrir se le repite el proceso

  while (digitalRead(FC1) == 0)  // Mientras el Final de Carrera no esté pulsado
  {
    digitalWrite(PE, HIGH); // Activa Pinzas
    digitalWrite(P, LOW); // Pinzas para abrir
  }

  if (digitalRead(FC1) == 1) // Si el Final de Carrera está pulsado
  {
    digitalWrite(PE, LOW); // Desactivar Pinzas
    nota(Si[2], 200); //Canción para avisar que ha abierto la pinza y se ha parado el motor
    nota(La[2], 200);
    nota(Sol[2], 200);
    noTone(BZ); delay(1000);
  }
}

void nota(int frec, int t) //Función para definir la música usando la frecuencia y el tiempo
{
  tone(BZ, frec); // Se le declara el pin del Buzzer a esta función
  delay(t);
}

void loop()
{
  char dato = Serial.read();  //lee el puerto serie (Rx y Tx)
  digitalWrite(L3, HIGH); // Se enciende el LED trasero centrar que simula la luz de encendido
  digitalWrite(L4, HIGH); // Se enciende los LEDs trasero laterales que simula la luz de parada
  switch (dato) // Se declara un switch para determinar varios carácteres que recoge por bluetooth
  {
    case 'a': // Caso para ir adelante
      digitalWrite(L1, HIGH); // Se enciende los LEDs delanteros para empezar a andar
      digitalWrite(L2, HIGH);
      digitalWrite(L4, LOW); // Se apaga los LEDs trasero laterales que simula la luz de parada para empezar a andar
      adelante(); // Llama la función ''adelante''
      digitalWrite(L1, LOW); // Se apagan los LEDs delanteros
      digitalWrite(L2, LOW);
      digitalWrite(L4, HIGH); //Se enciende los LEDs trasero laterales que simula la luz de parada
      E1 = 0; // Se inicializa los cuentapasos a 0
      E2 = 0;
      break;

    case 'b': // Caso para ir atrás
      digitalWrite(L4, LOW); //  Parpadeo del los LEDs traseros laterales para indicar que va a ir marcha atrás
      delay(200);
      digitalWrite(L4, HIGH);
      delay(200);
      digitalWrite(L4, LOW);
      delay(200);
      digitalWrite(L4, HIGH);
      delay(200);
      digitalWrite(L4, LOW);
      delay(200);
      atras();
      digitalWrite(L4, HIGH);
      E1 = 0; // Se inicializa los cuentapasos a 0
      E2 = 0;
      break;

    case 'c': // Caso para girar a la izquierda
      digitalWrite(L2, HIGH); //Se enciende el LED de la izquierda para girar a la izquierda
      digitalWrite(L4, LOW); // Se apaga los LEDs trasero laterales que simula la luz de parada para empezar a andar
      izquierda(); // Llama a la función de giro a la izquierda
      digitalWrite(L4, HIGH); //Se enciende los LEDs trasero laterales que simula la luz de parada
      digitalWrite(L2, LOW); // Se apaga el LED de giro a la izquierda
      E1 = 0; // Se inicializa los cuentapasos a 0
      E2 = 0;
      while (E2 < 40) // Mientras que el encoder 2 cambie 40 veces para ir hacia atrás y ajustarse al giro
      {
        analogWrite(M1E, SPD1); // Activa Motor Derecho a la velocidad escogida, 50% si no elije nada
        analogWrite(M2E, SPD2); // Activa Motor Izquierda a la velocidad escogida, 50% si no elije nada
        digitalWrite(M1, LOW); // Motor Derecho hacia atrás
        digitalWrite(M2, LOW); // Motor Izquierda hacia atrás
      }
      digitalWrite(M1E, LOW); // Desactiva Motor Derecho
      digitalWrite(M2E, LOW); // Desactiva Motor Izquierda
      E1 = 0; // Se inicializa los cuentapasos a 0
      E2 = 0;
      break;

    case 'd': // Caso para girar a la derecha
      digitalWrite(L4, LOW); // Se apaga los LEDs trasero laterales que simula la luz de parada para empezar a andar
      digitalWrite(L1, HIGH); //Se enciende el LED de la derecha para girar a la derecha
      derecha(); // Llama a la función de giro a la derecha
      digitalWrite(L4, HIGH); //Se enciende los LEDs trasero laterales que simula la luz de
      digitalWrite(L1, LOW); // Se apaga el LED de giro a la derecha
      E1 = 0;// Se inicializa los cuentapasos a 0
      E2 = 0;
      while (E2 < 40) // Mientras que el encoder 2 cambie 40 veces para ir hacia atrás y ajustarse al giro
      {
        analogWrite(M1E, SPD1); // Activa Motor Derecho a la velocidad escogida, 50% si no elije nada
        analogWrite(M2E, SPD2); // Activa Motor Izquierda a la velocidad escogida, 50% si no elije nada
        digitalWrite(M1, LOW); // Motor Derecho hacia atrás
        digitalWrite(M2, LOW); // Motor Izquierda hacia atrás
      }
      digitalWrite(M1E, LOW); // Desactiva Motor Derecho
      digitalWrite(M2E, LOW); // Desactiva Motor Izquierda
      E1 = 0; // Se inicializa los cuentapasos a 0
      E2 = 0;
      break;

    case 'e': // Caso para abrir las pinzas
      digitalWrite(L1, HIGH); // Parpadeo del todos los LEDs para indicar que va a mover las pinzas
      digitalWrite(L2, HIGH);
      digitalWrite(L3, HIGH);
      digitalWrite(L4, HIGH);
      delay(200);
      digitalWrite(L1, LOW);
      digitalWrite(L2, LOW);
      digitalWrite(L3, LOW);
      digitalWrite(L4, LOW);
      delay(200);
      digitalWrite(L1, HIGH);
      digitalWrite(L2, HIGH);
      digitalWrite(L3, HIGH);
      digitalWrite(L4, HIGH);
      delay(200);
      digitalWrite(L1, LOW);
      digitalWrite(L2, LOW);
      digitalWrite(L3, LOW);
      digitalWrite(L4, LOW);
      delay(200);
      abrir_pinzas();
      digitalWrite(L4, HIGH);
      break;

    case 'f':  // Función para cerrar las pinzas
      digitalWrite(L1, HIGH); // Parpadeo del todos los LEDs para indicar que va a mover las pinzas
      digitalWrite(L2, HIGH);
      digitalWrite(L3, HIGH);
      digitalWrite(L4, HIGH);
      delay(200);
      digitalWrite(L1, LOW);
      digitalWrite(L2, LOW);
      digitalWrite(L3, LOW);
      digitalWrite(L4, LOW);
      delay(200);
      digitalWrite(L1, HIGH);
      digitalWrite(L2, HIGH);
      digitalWrite(L3, HIGH);
      digitalWrite(L4, HIGH);
      delay(200);
      digitalWrite(L1, LOW);
      digitalWrite(L2, LOW);
      digitalWrite(L3, LOW);
      digitalWrite(L4, LOW);
      delay(200);
      cerrar_pinzas();
      digitalWrite(L4, HIGH);
      break;

    case 'k':// Música 1 Entre dos aguas (Paco de Lucía)
      nota(La[1], 400); noTone(BZ); delay(400);
      nota(Mi[1], 400); noTone(BZ); delay(400);
      nota(La[1], 400); noTone(BZ); delay(200);
      nota(Mi[1], 200); noTone(BZ); delay(200);
      nota(La[1], 200); noTone(BZ); delay(200);
      nota(LaS[1], 100); noTone(BZ); delay(100);
      nota(Si[1], 400); noTone(BZ); delay(400);
      nota(FaS[1], 400); noTone(BZ); delay(400);
      nota(Si[1], 400); noTone(BZ); delay(200);
      nota(FaS[1], 200); noTone(BZ); delay(200);
      nota(Si[1], 200); noTone(BZ); delay(200);
      nota(LaS[1], 100); noTone(BZ); delay(100);
      nota(La[1], 400); noTone(BZ); delay(400);
      nota(Mi[1], 400); noTone(BZ); delay(400);
      nota(La[1], 400); noTone(BZ); delay(400);
      break;

    case 'l':// Música 2 Tema Principal (Star Wars)
      nota(Re[1], 150); noTone(BZ); delay(50);
      nota(Re[1], 150); noTone(BZ); delay(50);
      nota(Re[1], 150); noTone(BZ); delay(50);
      nota(Sol[1], 900); noTone(BZ); delay(150);
      nota(Re[2], 900); noTone(BZ); delay(50);
      nota(Do[2], 150); noTone(BZ); delay(50);
      nota(Si[1], 150); noTone(BZ); delay(50);
      nota(La[1], 150); noTone(BZ); delay(50);
      nota(Sol[2], 900); noTone(BZ); delay(150);
      nota(Re[2], 900); noTone(BZ); delay(100);
      nota(Do[2], 150); noTone(BZ); delay(50);
      nota(Si[1], 150); noTone(BZ); delay(50);
      nota(La[1], 150); noTone(BZ); delay(50);
      nota(Sol[2], 900); noTone(BZ); delay(150);
      nota(Re[2], 900); noTone(BZ); delay(100);
      nota(Do[2], 150); noTone(BZ); delay(50);
      nota(Si[1], 150); noTone(BZ); delay(50);
      nota(Do[2], 150); noTone(BZ); delay(50);
      nota(La[1], 1200); noTone(BZ); delay(2000);
      break;

    case 'm':// Música 3 Marcha del imperio (Star Wars)
      nota(Sol[1], 500); noTone(BZ); delay(100);
      nota(Sol[1], 500); noTone(BZ); delay(100);
      nota(Sol[1], 500); noTone(BZ); delay(100);
      nota(ReS[1], 500); noTone(BZ); delay(1);
      nota(LaS[1], 125); noTone(BZ); delay(25);
      nota(Sol[1], 500); noTone(BZ); delay(100);
      nota(ReS[1], 500); noTone(BZ); delay(1);
      nota(LaS[1], 125); noTone(BZ); delay(25);
      nota(Sol[1], 500); noTone(BZ); delay(2000);
      break;

    case 'n'://Música 4 HARRY POTTER
      nota(Si[1], 500);
      nota(Mi[2], 1000);
      nota(Sol[2], 250);
      nota(FaS[2], 250);
      nota(Mi[2], 1000);
      nota(Si[2], 500);
      nota(La[2], 1250);
      nota(FaS[2], 1000);
      nota(Si[1], 500);
      nota(Mi[2], 1000);
      nota(Sol[2], 250);
      nota(FaS[2], 250);
      nota(Re[2], 1000);
      nota(Mi[2], 500 );
      nota(Si[1], 1000 );
      noTone(BZ); delay(1000);
      nota(Si[1], 500);
      nota(Mi[2], 1000);
      nota(Sol[2], 250);
      nota(FaS[2], 250);
      nota(Mi[2], 1000);
      nota(Si[2], 500);
      nota(Re[3], 1000);
      nota(DoS[3], 500);
      nota(Do[3], 1000);
      nota(La[2], 500);
      nota(Do[3], 1000);
      nota(Si[2], 250);
      nota(LaS[2], 250);
      nota(Si[1], 1000);
      nota(Sol[2], 500);
      nota(Mi[2], 1000);
      noTone(BZ); delay(2000);
      break;

    case 'g': // Grupo Leds 1
      digitalWrite(L1, HIGH);
      delay(200);
      digitalWrite(L1, LOW);
      digitalWrite(L4, HIGH);
      delay(200);
      digitalWrite(L4, LOW);
      digitalWrite(L2, HIGH);
      delay(200);
      digitalWrite(L2, LOW);
      digitalWrite(L3, HIGH);
      delay(200);
      digitalWrite(L3, LOW);
      digitalWrite(L1, HIGH);
      delay(200);
      digitalWrite(L1, LOW);
      digitalWrite(L4, HIGH);
      delay(200);
      digitalWrite(L4, LOW);
      digitalWrite(L2, HIGH);
      delay(200);
      digitalWrite(L2, LOW);
      digitalWrite(L3, HIGH);
      delay(200);
      digitalWrite(L3, LOW);
      digitalWrite(L1, HIGH);
      delay(200);
      digitalWrite(L1, LOW);
      digitalWrite(L4, HIGH);
      delay(200);
      digitalWrite(L4, LOW);
      digitalWrite(L2, HIGH);
      delay(200);
      digitalWrite(L2, LOW);
      digitalWrite(L3, HIGH);
      delay(200);
      digitalWrite(L3, LOW);
      delay(200);
      break;

    case 'h': //Grupo Leds2
      digitalWrite(L1, HIGH);
      delay(200);
      digitalWrite(L3, HIGH);
      digitalWrite(L4, HIGH);
      delay(200);
      digitalWrite(L1, LOW);
      digitalWrite(L2, HIGH);
      delay(200);
      digitalWrite(L3, LOW);
      digitalWrite(L4, LOW);
      delay(200);
      digitalWrite(L2, LOW);
      delay(200);
      digitalWrite(L2, HIGH);
      delay(200);
      digitalWrite(L3, HIGH);
      digitalWrite(L4, HIGH);
      delay(200);
      digitalWrite(L1, HIGH);
      digitalWrite(L2, LOW);
      delay(200);
      digitalWrite(L3, LOW);
      digitalWrite(L4, LOW);
      delay(200);
      digitalWrite(L1, LOW);
      delay(200);
      break;

    case 'i': //Grupo Leds3
      digitalWrite(L1, HIGH);
      delay(200);
      digitalWrite(L3, HIGH);
      delay(200);
      digitalWrite(L1, LOW);
      digitalWrite(L2, HIGH);
      delay(200);
      digitalWrite(L3, LOW);
      digitalWrite(L4, HIGH);
      delay(200);
      digitalWrite(L2, LOW);
      digitalWrite(L1, HIGH);
      delay(200);
      digitalWrite(L4, LOW);
      digitalWrite(L3, HIGH);
      delay(200);
      digitalWrite(L1, LOW);
      digitalWrite(L2, HIGH);
      delay(200);
      digitalWrite(L3, LOW);
      digitalWrite(L4, HIGH);
      delay(200);
      digitalWrite(L2, LOW);
      digitalWrite(L1, HIGH);
      delay(200);
      digitalWrite(L4, LOW);
      digitalWrite(L3, HIGH);
      delay(200);
      digitalWrite(L1, LOW);
      digitalWrite(L2, HIGH);
      delay(200);
      digitalWrite(L3, LOW);
      digitalWrite(L4, HIGH);
      delay(200);
      digitalWrite(L2, LOW);
      digitalWrite(L1, HIGH);
      delay(200);
      digitalWrite(L4, LOW);
      delay(200);
      digitalWrite(L1, LOW);
      delay(200);
      break;

    case 'j':// Grupo Leds4
      digitalWrite(L1, HIGH);
      delay(200);
      digitalWrite(L2, HIGH);
      delay(200);
      digitalWrite(L1, LOW);
      digitalWrite(L3, HIGH);
      delay(200);
      digitalWrite(L2, LOW);
      digitalWrite(L4, HIGH);
      delay(200);
      digitalWrite(L3, LOW);
      delay(200);
      digitalWrite(L4, LOW);
      delay(200);
      digitalWrite(L4, HIGH);
      delay(200);
      digitalWrite(L3, HIGH);
      delay(200);
      digitalWrite(L4, LOW);
      digitalWrite(L2, HIGH);
      delay(200);
      digitalWrite(L3, LOW);
      digitalWrite(L1, HIGH);
      delay(200);
      digitalWrite(L2, LOW);
      delay(200);
      digitalWrite(L1, LOW);
      delay(200);
      break;

    case '0': // Velocidad 0
      SPD1 = 0;
      SPD2 = 0;
      break;

    case '1': // Velocidad 1
      SPD1 = 50;
      SPD2 = 51;
      break;

    case '2': // Velocidad 2
      SPD1 = 75.5;
      SPD2 = 76.5;
      break;

    case '3': // Velocidad 3
      SPD1 = 101;
      SPD2 = 102;
      break;

    case '4':// Velocidad 4 (50%)
      SPD1 = 126.5;
      SPD2 = 127.5;
      break;

    case '5':// Velocidad 5
      SPD1 = 152;
      SPD2 = 153;
      break;

    case '6':// Velocidad 6
      SPD1 = 177.5;
      SPD2 = 178.5;
      break;

    case '7':// Velocidad 7
      SPD1 = 203;
      SPD2 = 204;
      break;

    case '8':// Velocidad 8
      SPD1 = 228.5;
      SPD2 = 229.5;
      break;

    case '9':// Velocidad 9
      SPD1 = 254;
      SPD2 = 255;
      break;
  }
}

